/*
 * DbApplication.java
 *
 * Created on 28. Mai 2001, 14:51 by Christoph Knabe
 */

package bank3tier.db;

/**
 * The application specific database access methods are grouped by this interface.
 * @author  2001-05-28  Christoph Knabe
 */
public interface DbApplication {

    /**Opens an application specific JORA database.*/
    void openDB();

    /**Returns the JORA session used to access the application database.
       Requires: openDB() was successfully executed before.
    */
    jora.Session getSession();

    /**Creates application specific tables*/
    void createTables(final String i_oidSuffix) throws java.sql.SQLException;

    /**Deletes the application specific database tables.*/
    void deleteTables() throws java.sql.SQLException;

}