/*
 * DbBankApplication.java
 *
 * Created on 28. Mai 2001, 14:59
 */

package bank3tier.db;

/**
 * Groups all application specific database access code.
 * @author  Christoph Knabe at 2001-05-27
 */
public class DbBankApplication implements DbApplication {

    /** Creates new DbBankApplication */
    public DbBankApplication() {
    }

    public void openDB(){
        //Instead of the following line you could create a JORA session
        //using another constructor giving another driver than the default one.
        _session = new jora.Session();
        _session.open("jdbc:odbc:Bank3Tier", "", "");
    }

    public jora.Session getSession(){return _session;}

    /**Creates the DB tables Kunde, Konto, Verwaltet in SQL for Access97*/
    public void createTables(final String i_oidSuffix)
    throws java.sql.SQLException {
	_session.execute("create table Kunde ("
            +" oid INTEGER CONSTRAINT KundeKey PRIMARY KEY"
            +",db__updateVersion INTEGER NOT NULL"
            +",name VARCHAR(50) NOT NULL"
            +",geburt DATE NOT NULL"
            +" )"
        );
	_session.execute("create table Konto ("
            +" oid INTEGER CONSTRAINT KontoKey PRIMARY KEY"
            +",db__updateVersion INTEGER NOT NULL"
            +",saldo INTEGER NOT NULL"
            +",eroeffnet DATE NOT NULL"
            +",geschlossen DATE"
            +" )"
        );
	_session.execute("create table Verwaltet ("
            +" oid INTEGER CONSTRAINT VerwaltetKey PRIMARY KEY"
            +",db__updateVersion INTEGER NOT NULL"
            +",kunde" + i_oidSuffix + " INTEGER NOT NULL"
            +",konto" + i_oidSuffix + " INTEGER NOT NULL"
            +",inhaber LOGICAL NOT NULL"
            +" )"
        );
    }//createTables

    /**Deletes the application specific tables Kunde, Konto, Verwaltet*/
    public void deleteTables(){
        _session.execute("drop table Kunde");
        _session.execute("drop table Konto");
        _session.execute("drop table Verwaltet");
    }

    private jora.Session _session;

}