/*
 * System.java
 *
 * Created on 19. Mai 2001, 09:01
 */

package bank3tier.lg;
import bank3tier.db.DbService;
import bank3tier.db.DbBankApplication;
/**
  Steht fr die Applikation als Ganzes. Enthlt eine Operation zur
  Initialisierung der Applikation sowie statische Operationen zum Erfassen
  einiger Startobjekte, von denen ausgehend weitere Objekte mit Hilfe von
  Objektoperationen erfat werden.
 * @author  Christoph Knabe
 */
public class LgApplication {

    /** Initializes the system.*/
    public static void init() throws multex.Failure {
        try {
            DbService.dbOpen(new DbBankApplication());
            /*
            //Alten Datenbankzustand lschen: Klappt nicht mit JORA/Access
            try{DbService.dbDeleteTables();}
            catch(Exception ex){System.err.println("Error deleting old DB: ");
                multex.Msg.printMessages(ex);
            }
            */
            //Neue leere Tabellen anlegen:
            DbService.dbCreateTables();

            //Dummy-Objekte als Zugnge fr suchen()-Operationen erzeugen:
            _dummyKunde = new LgKundeImpl();
        } catch(Exception ex){
            throw new multex.Failure("Error initializing the system", ex);
        }
    }

    /**Returns a new empty LgKunde object*/
    public static LgKunde newKunde(){
        return new LgKundeImpl();
    }

    /**Returns a shared dummy LgKunde object for suchen operations*/
    public static LgKunde dummyKunde(){return _dummyKunde;}

    /**Dummy-Kunde zur Ermglichung von Objektoperationen fr Objektverwaltung*/
    public static LgKunde _dummyKunde;

}