package bank3tier.lg; //LgKontoStand_List.java:

//2001-05-06  Knabe  With new method addAll(jora.Cursor)
//2001-05-06  Knabe  Checking of LgKontoStand type correctness improved
//2001-04-26  Knabe  Einbringung der Layout-Verbesserungen von B. Krischker 30.4.00
//2000-06-15  Knabe  Zuordnung zu Paket lib
//2000-03-17  Knabe  Creation
//Autor: Christoph Knabe

import java.lang.String;

/** Generische Klasse fuer typsichere Verpackung einer java.util.List.
  * Eine LgKontoStand_List kann nur mit LgKontoStanden des Typs LgKontoStand gefllt
  * werden! Dadurch ist bei der Entnahme keine Typspezialisierung
  * notwendig.
  * Nur die wichtigsten Methoden von List werden durchgereicht!
  * Weitere knnen ergnzt werden.
  * <P>
  * Instanzierung: Globales Ersetzen aller "LgKontoStand" durch "Typname"
*/

/*
 * @see Collection
 * @see Set
 * @see ArrayList
 * @see LinkedList
 * @see Vector
 * @see Arrays#asList(Object[])
 * @see Collections#nCopies(int, Object)
 * @see Collections#EMPTY_LIST
 * @see AbstractList
 * @see AbstractSequentialList
 * @since JDK1.2
 */

public class LgKontoStand_List implements java.io.Serializable{
  //project specific various methods:
  public void addAll(jora.Cursor c) throws LgKontoStand_List.IllegalLgKontoStandType {
    for(;;){
      final Object o = c.next();
      if(o==null){break;}
      check(o);
      add((LgKontoStand)o);
    }
  }


  /*The wrapped List*/
  private final java.util.List _wrapped;

  // Constructors:
  public LgKontoStand_List(){
    _wrapped = new java.util.ArrayList();
  }
  public LgKontoStand_List(final java.util.List i_list)throws IllegalLgKontoStandType {
    checkAll(i_list);
    _wrapped = i_list;
  }

  // Query Operations:
  public int size(){
    return _wrapped.size();
  }
  public boolean isEmpty(){
    return _wrapped.isEmpty();
  }
  public boolean contains(LgKontoStand o){
    return _wrapped.contains(o);
  }
  public String toString(){
    return _wrapped.toString();
  }

  //?Iterator iterator();
  //?Object[] toArray();
  //?Object[] toArray(Object a[]);

  // Modification Operations:
  public boolean add(LgKontoStand o){
    return _wrapped.add(o);
  }

  // Bulk Modification Operations: ???zustzlich fr LgKontoStand_List?
  public boolean containsAll(java.util.Collection c){
    return _wrapped.containsAll(c);
  }
  public boolean addAll(java.util.Collection c) throws LgKontoStand_List.IllegalLgKontoStandType {
    checkAll(c);
    return _wrapped.addAll(c);
  }
  public boolean addAll(int index, java.util.Collection c) throws LgKontoStand_List.IllegalLgKontoStandType{
    checkAll(c);
    return _wrapped.addAll(index,c);
  }
  public boolean removeAll(java.util.Collection c){
    return _wrapped.removeAll(c);
  }
  public boolean retainAll(java.util.Collection c){
    return _wrapped.retainAll(c);
  }
  public void clear(){
    _wrapped.clear();
  }

  // Comparison and hashing:
  public boolean equals(Object o){
    return _wrapped.equals(((LgKontoStand_List)o)._wrapped);
  }
  public int hashCode(){
    return _wrapped.hashCode();
  }

  // Positional Access Operations:
  public LgKontoStand get(int index){
    return (LgKontoStand)_wrapped.get(index);
  }
  public LgKontoStand set(int index, LgKontoStand LgKontoStand){
    return (LgKontoStand)_wrapped.set(index,LgKontoStand);
  }
  public void add(int index, LgKontoStand LgKontoStand){
    _wrapped.add(LgKontoStand);
  }
  public LgKontoStand remove(int index){
    return (LgKontoStand)_wrapped.remove(index);
  }

  // Search Operations:


  public boolean remove(LgKontoStand o){
      return _wrapped.remove(o);
    }

  public int indexOf(LgKontoStand o){
    return _wrapped.indexOf(o);
  }
  public int lastIndexOf(LgKontoStand o){
    return _wrapped.lastIndexOf(o);
  }

  // List Iterators:
  public Iterator listIterator(){
    return new Iterator(_wrapped.listIterator());
  }
  public Iterator listIterator(int index){
    return new Iterator(_wrapped.listIterator(index));
  }

  // View:
  LgKontoStand_List subList(int fromIndex, int toIndex){
    final java.util.List subList = _wrapped.subList(fromIndex, toIndex);
    return new LgKontoStand_List(subList, true); //unchecked
  }

  //Additions for LgKontoStand_List:

  /*Returns an unmodifiable view of the wrapped Object-list.
    Useful, if you want to process the contents of this list by the java.util.List
    or the java.util.Collection interface. The returned view is unmodifiable in
    order to guarantee the type-safety. Query operations on the returned list
    "read through" to the specified list, and attempts to modify the returned
    list, whether direct or via its iterator, result in an
    UnsupportedOperationException.

    @see java.lang.UnsupportedOperationException
  */

  public java.util.List objectList(){
    return java.util.Collections.unmodifiableList(_wrapped);
  }

  public static class IllegalLgKontoStandType extends Exception {
    public IllegalLgKontoStandType(final String i_typeName){
      super(i_typeName);
    }
  }

  /**@throws IllegalLgKontoStandType If there is an LgKontoStand of i_collection, which is
    not of type LgKontoStand.
  */
  public static void checkAll(final java.util.Collection i_collection)
  throws IllegalLgKontoStandType {
    for(final java.util.Iterator i = i_collection.iterator(); i.hasNext(); ){
      final Object o = i.next();
      check(o);
    }
  }

  /**@throws IllegalLgKontoStandType If there i_LgKontoStand is not of type LgKontoStand.
  */
  public static void check(final Object i_LgKontoStand)
  throws IllegalLgKontoStandType {
    if(!(i_LgKontoStand instanceof LgKontoStand)){
      throw new IllegalLgKontoStandType( i_LgKontoStand.getClass().getName()
        + " is not instance of " + LgKontoStand.class.getClass().getName()
      );
    }
  }


  /**
    A type-safe iterator for an LgKontoStand_List that allows the programmer to
    traverse the list in either direction and modify the list during iteration.
    Built like java.util.ListIterator and documented there.
  */
  public static class Iterator {

    private java.util.ListIterator _wrapped;

    // Constructor
    private Iterator(final java.util.ListIterator i_listIterator){
      _wrapped = i_listIterator;
    }

    // Query Operations
    public boolean hasNext(){
      return _wrapped.hasNext();
    }
    public LgKontoStand next(){
      return (LgKontoStand)_wrapped.next();
    }
    public boolean hasPrevious(){
      return _wrapped.hasPrevious();
    }
    public LgKontoStand previous(){
      return (LgKontoStand)_wrapped.previous();
    }
    public int nextIndex(){
      return _wrapped.nextIndex();
    }
    public int previousIndex(){
      return _wrapped.previousIndex();
    }

    // Modification Operations
    public void remove(){
      _wrapped.remove();
    }
    public void set(LgKontoStand o){
      _wrapped.set(o);
    }
    public void add(LgKontoStand o){
      _wrapped.add(o);
    }
  }

   public static abstract class Comparator implements java.util.Comparator {

    public final int compare(Object object1, Object object2){
      final LgKontoStand LgKontoStand1 = (LgKontoStand)object1;
      final LgKontoStand LgKontoStand2 = (LgKontoStand)object2;
      return compare(LgKontoStand1, LgKontoStand2);
    }

    /**should be implemented by implementor of this abstract class*/
    public abstract int compare(LgKontoStand LgKontoStand1, LgKontoStand LgKontoStand2);
  }

  /**Sorts the LgKontoStands of this LgKontoStand_List into ascending order, according to
    the natural ordering of its LgKontoStands.
  */
  public void sort(){
    java.util.Collections.sort(_wrapped);
  }

  /**Sorts the LgKontoStands of this LgKontoStand_List using the given typed comparator.
    @see java.util.Comparator
  */
  public void sort(final Comparator i_comparator){
    java.util.Collections.sort(_wrapped, i_comparator);
  }

  public void reverse(){
    java.util.Collections.reverse(_wrapped);
  }

  /**unchecked private constructor to wrap a java.util.List into an LgKontoStand_List*/
  private LgKontoStand_List(final java.util.List i_list, final boolean i_unchecked){
    _wrapped = i_list;
  }


}//LgKontoStand_List
