package bank3tier.lg; //LgKunde.java

import bank3tier.db.DbObject;

/*
 * LgKunde.java
 *
 * Created on 4. April 2002, 15:45
    Knabe: Klasse LgKunde aufgeteilt in Interface LgKunde + Klasse LgKundeImpl
 */


/**
 * Ein Kunde einer Bank.
 * @author  Christoph Knabe
 * @version
 */
public interface LgKunde extends LgObject {


    /*Gets/Sets these attributes in the actual object.
      As internal, unpersistent operation
    */
    String getName();
    LgDatum getGeburt();
    void setName(String i_name);
    void setGeburt(LgDatum i_geburt);

    /**Inserts this Kunde object into the database*/
    void erfassen();

    /**Erffnet ein neues Konto, dessen Inhaber der aktuelle Kunde wird.
      As external checked transaction.
      @return das neue Konto
    */
    LgKonto kontoErffnen();

    /**Liefert alle Kunden*/
    LgKunde_List alleSuchen(); //static

    /**Liefert den Kunden mit dem angegebenen Geburtsdatum*/
    LgKunde suchen(final LgDatum i_geburtsDatum) //static
    throws KeinKundeExc;

    /**Liefert ein View-Objekt mit allen Konten des aktuellen Kunden
      mit ihrem Saldo und Inhaberstatus.
    */
    LgKontoStand_List getKontoStandList();

    public static class KeinKundeExc extends multex.Exc {
        public KeinKundeExc(final java.sql.Date i_geburtsDatum){
            super("Es wurde kein Kunde mit Geburtsdatum {0,date} gefunden", i_geburtsDatum);
        }
    }

}
